unit Psapi;

{$IMPORTEDDATA OFF}

interface

uses Windows;

type
  SIZE_T = Cardinal;
  PHMODULE = ^HMODULE;

  PROCESS_MEMORY_COUNTERS = record
    cb: DWORD;
    PageFaultCount: DWORD;
    PeakWorkingSetSize: SIZE_T;
    WorkingSetSize: SIZE_T;
    QuotaPeakPagedPoolUsage: SIZE_T;
    QuotaPagedPoolUsage: SIZE_T;
    QuotaPeakNonPagedPoolUsage: SIZE_T;
    QuotaNonPagedPoolUsage: SIZE_T;
    PagefileUsage: SIZE_T;
    PeakPagefileUsage: SIZE_T;
  end;
  PPROCESS_MEMORY_COUNTERS = ^PROCESS_MEMORY_COUNTERS;

  MODULEINFO = record
    lpBaseOfDll: Pointer;
    SizeOfImage: DWORD;
    EntryPoint: Pointer;
  end;
  LPMODULEINFO = ^MODULEINFO;

  PERFORMANCE_INFORMATION = record
    cb: DWORD;
    CommitTotal: SIZE_T;
    CommitLimit: SIZE_T;
    CommitPeak: SIZE_T;
    PhysicalTotal: SIZE_T;
    PhysicalAvailable: SIZE_T;
    SystemCache: SIZE_T;
    KernelTotal: SIZE_T;
    KernelPaged: SIZE_T;
    KernelNonpaged: SIZE_T;
    PageSize: SIZE_T;
    HandleCount: DWORD;
    ProcessCount: DWORD;
    ThreadCount: DWORD;
  end;
  PPERFORMANCE_INFORMATION = ^PERFORMANCE_INFORMATION;

var
  EnumProcesses: function (pProcessIds: PDWORD; cb: DWORD;
    pBytesReturned: PDWORD): BOOL; stdcall;
  EnumProcessModules: function (hProcess: THandle; lphModule: PHMODULE;
    cb: DWORD; lpcbNeeded: LPDWORD): BOOL; stdcall;
  GetMappedFileName: function (hProcess: THandle; lpv: Pointer;
    lpFileName: LPTSTR; nSize: DWORD): DWORD; stdcall;
  GetModuleBaseName: function (hProcess: THandle; hModule: HMODULE;
    lpBaseName: LPTSTR; nSize: DWORD): DWORD; stdcall;
  GetModuleFileNameEx: function (hProcess: THandle; hModule: HMODULE;
    lpFileName: LPTSTR; nSize: DWORD): DWORD; stdcall;
  GetModuleInformation: function (hProcess: THandle; hModule: HMODULE;
    lpmodinfo: LPMODULEINFO; cb: DWORD): BOOL; stdcall;
  GetPerformanceInfo: function (
    pPerformanceInformation: PPERFORMANCE_INFORMATION; cb: DWORD): BOOL;
    stdcall;
  GetProcessMemoryInfo: function (hProcess: THandle;
    ppsmemCounters: PPROCESS_MEMORY_COUNTERS; cb: DWORD): BOOL; stdcall;
  GetProcessImageFileName: function (hProcess: Thandle;
    lpImageFileName: LPTSTR; nSize:DWORD): DWORD; stdcall;

implementation

uses NDllLoader;

var
  h: HMODULE;
begin
  h := LoadDLL('psapi.dll');
  if h = 0 then
    Exit;
  EnumProcesses := GetProcAddress(h, 'EnumProcesses');
  EnumProcessModules := GetProcAddress(h, 'EnumProcessModules');
  GetMappedFileName := GetProcAddress(h, 'GetMappedFileNameA');
  GetModuleBaseName := GetProcAddress(h, 'GetModuleBaseNameA');
  GetModuleFileNameEx := GetProcAddress(h, 'GetModuleFileNameExA');
  GetModuleInformation := GetProcAddress(h, 'GetModuleInformation');
  GetProcessMemoryInfo := GetProcAddress(h, 'GetProcessMemoryInfo');
  // XP or later
  GetPerformanceInfo := GetProcAddress(h, 'GetPerformanceInfo');
  GetProcessImageFileName := GetProcAddress(h, 'GetProcessImageFileNameA');
end.
